#-*-coding:utf-8-*-

from scapy.all import *
from bs4 import BeautifulSoup
import urllib2
import db
import threading
from termcolor import colored
import re

global LOAD
LOAD = False
global VERBOSE
VERBOSE = False

def loading():
	i = 0
	while not LOAD:
		if i % 4 == 0:
			print "\r|",
		elif i % 4 == 1:
			print "\r/",
		elif i % 4 == 2:
			print "\r-",
		else:
			print "\r\\",
		time.sleep(0.3)	
	
		sys.stdout.flush()
		i += 1
	print ""


def main(path):
	#guardamos ruta del .pcap
	pcap_path = path 
	global VERBOSE

	
	global LOAD
	a = threading.Thread(target=loading)

	a.start()
	#time.sleep(1)
	pcap = rdpcap(pcap_path)

	LOAD = True
	http_packets = []
	
	#búsqueda de paquetes HTTP
	#http_packets contiene los paquetes http
	for packet in xrange(len(pcap)):
		if "TCP" in pcap[packet] and pcap[packet].dport == 80:
			if "Raw" in pcap[packet]:
				# print pcap[packet]
				http_packets.append(pcap[packet])
	#totalHTTP contiene el numero de las REQUEST HTTP	
	totalHTTP = len([i for i in pcap if "TCP" in i and i.dport == 80 and "Raw" in i])
	totalHTTPreal = len([i for i in pcap if "TCP" in i and (i.dport == 80 or i.sport==80) and "Raw" in i])
	#host_requests contiene un diccionario de listas con los hosts y los paquetes que contiene
	host_requests = {"Others": []}
	
	#se agregan nuevos hosts al diccionario en caso de no estar
	for packet in http_packets:
		
		if "Referer:" not in str(packet['TCP'].payload):
			headers = str(packet['TCP'].payload).lower()
			
			if "host" in headers:
				ind = headers.index("host: ") + 6
				host = headers[ind: ind + headers[ind:].index("\n")].strip()
				
				if host not in host_requests:
					host_requests[host] = []
		
	#se agregan los paquetes a las listas de los diccionarios
	for packet in xrange(len(http_packets)):
		if "Referer:" in str(http_packets[packet]['TCP'].payload):
		
			headers = str(http_packets[packet]['TCP'].payload).lower()
			if "referer: " in headers:
				ind = headers.index("referer: ") + 9
				referer = headers[ind: ind + headers[ind:].index("\n")].strip()
				
				if referer.index("http://") == 0:
					referer = referer[7:]

				if referer.index("/") != -1:
					referer = referer[:referer.index("/")]
				
				if referer in host_requests:
					host_requests[referer].append(packet)
				else:
					host_requests['Others'].append(packet)

		else:
			host_requests['Others'].append(packet)
	

	#print "-----------------------------------------------"		
	#print host_requests
	if VERBOSE: print "-------------------------------------------------------------------------"
	if VERBOSE: print "######## PAQUETES SIN REFERER ########"
	if VERBOSE: print "-------------------------------------------------------------------------"
	for clave in host_requests:
		if len(host_requests[clave]) != 0:
			if VERBOSE: print clave + ": " + str(host_requests[clave]) 
			

	if VERBOSE: print "---------------------------------------------------------------------------"
	# Tenemos el diccionario creado, ahora vamos a mapearlo con las peticiones href y sources de la página web

	

	web_pages = [i for i in host_requests.keys()]
	
	#web_references es un diccionario clave-valor donde la clave son las webs y el valor es un listado de los hrefs en el código fuente
	web_references = {}

	for web in web_pages:

		href_list = []

 		if web != "Others":

 			try:
 				
				print ""				
				print colored("Extrayendo información de ", 'yellow') + web,

				req = urllib2.Request("http://" + web, headers={'User-Agent' : 'Mozilla/5.0'})
				address = urllib2.urlopen(req, timeout=5)
				web_content = address.read()

	 			file_dir = "webPages/" + web

				with open(file_dir, 'w+') as doc:
					doc.write(web_content)

				with open(file_dir, 'r') as doc:
					for line in doc:
						web_content += line

				soup = BeautifulSoup(web_content, "lxml")

				href_list = []
				for a in soup.find_all(href=True):
					href_list.append(a.get('href'))


				for a in soup.find_all(src=True):					
					href_list.append(a.get('src'))
					
				
 			except Exception, e:
 				print colored (" ERROR - posible malware? ", 'red'), e

	
		web_references[web] = href_list
	print ""
	#print "web references:"
	#print web_references['www.androasia.es']
	# Cosas malas:
	#  host_requests['Others']
	#  host_requests[web] que no estén en web_references[web]

	# web_references -> Links que hay en la página web (reales)

	# host_requests son las peticiones que se hacen desde el pcap
	# requester es la web

	permitido = []
	ilicito = []
	
	##
	
	##

	for requester in host_requests:

		for req in host_requests[requester]:
			
			# Queremos los indices de req de esto -> http_packets
			
			this_resource = str(http_packets[req]['Raw']).split("\n")[0].split()[1]

			this_host = str(http_packets[req]['Raw']).split("\n")[1].split()[1]

			# raw_input()

			if la_url_esta_permitida(this_resource, web_references[requester], this_host):
				permitido.append(http_packets[req])
			#else: 
				#ilicito.append(http_packets[req])
			else: 
				ilicito.append(http_packets[req])
			# raw_input() 

	ilicito += [http_packets[i] for i in host_requests['Others']]
	juntos = ilicito+permitido
	
	##########################################################
	#print colored('hello','red'), colored('green','green')
		
	print "---------------------------------------------------"
	#print host_requests.keys()
	count = 0
	for l in host_requests.keys():
		if l != "Others": print colored("-Paquetes de: " + str(l), 'cyan')
		for c in juntos:
			if l in str(c):
				varGET = re.findall('GET (.*?) HTTP',str(c))
				varPOST = re.findall('POST (.*?) HTTP',str(c))
				if c in ilicito:
					if len(varGET) != 0: print colored("               Recurso %.50s ..." % (str(varGET)),'red')# + "%.50s" % (str(var))
					else: print colored("               Recurso %.50s ..." % (str(varPOST)),'red')
			 	else: 
					if len(varGET) != 0: print colored("               Recurso %.50s ..." % (str(varGET)),'green')# + "%.50s" % (str(var))
					else: print colored("               Recurso %.50s ..." % (str(varPOST)),'green')
		


	
	print "---------------------------------------------------"
	#for host_name in host_requests.keys():
		#print host_name
	#print len(ilicito)
	
	##########################################################
	
	if VERBOSE: print "OTROS:"+ host_requests['Others']
	print colored("Escribiendo los paquetes ilicitos en suspicious_requests.pcap",'green')+". " + colored("%d paquetes ilicitos" % (len(ilicito)), 'red')
	
	print "-------------------------------------------------"	
	print "Número de paquetes de tipo \"Request\" ilicitos: %d de %d = %.2f" % (len(ilicito),totalHTTP,(float(len(ilicito)*1.0))/(totalHTTP*1.0)) + "%"
	print "-------------------------------------------------"
	print colored("Porcentaje de reduccion REQUEST:",'green',attrs=['bold'])+ colored(" %.2f" % (1-(float(len(ilicito)*1.0))/(totalHTTP*1.0)) + "%",'green',attrs=['bold'])
	print "-------------------------------------------------"
	print "Número de request sobre número de paquetes HTTP: %d de %d = %.2f" % (len(ilicito),totalHTTPreal,len(ilicito)*1.0/totalHTTPreal*1.0) + "%"
	print "-------------------------------------------------"
	print colored("Porcentaje de reduccion HTTP:",'green',attrs=['bold'])+ colored(" %.2f" % (1-(float(len(ilicito)*1.0))/(totalHTTPreal*1.0)) + "%",'green',attrs=['bold'])
	#db.main("suspicious_requests.pcap", False, True, ilicito)
		
	pktdump = PcapWriter("suspicious_requests.pcap", True, True,)
	pktdump.write(ilicito)


def la_url_esta_permitida(resource, reference_list, host):

	# if resource[1:4] == "img":
	# 	print resource, host, reference_list

	
	for ref in reference_list:
		
		if ref[0] != "/":
			
			if resource.lower() == ref[len("http://" + host):].lower() :
				return True
			elif resource.lower() == ref[len("https://" + host):].lower():
				return True
			
		else:
		
			if resource == ref:
				return True

	return False

